/////////////////////////////////////////////////////////////////////////////////
// Company: 人о·Ƽ޹˾
// Engineer: С÷Ŷ
// Web: www.corecourse.cn
// 
// Create Date: 2019/05/01 00:00:00
// Design Name: 
// Module Name: data_scan_ctrl_tb
// Project Name: 
// Target Devices: XC7A35T-2FGG484I
// Tool Versions: Vivado 2018.3
// Description: data_scan_ctrlļ
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////
`timescale 1ns/1ns
`define CLK_PERIOD 20

module dync_char_tft_tb();
	reg          clk50M;
	reg          reset_n;

	reg          scan_en_pulse;
	reg [39:0]   disp_data;

	wire         pll_locked;
	wire         clk_ctrl;
	wire         sys_reset_n;
	wire [15:0]  tft_disp_data;
	wire         tft_disp_data_req;
	wire [11:0]  visible_hcount;
	wire [11:0]  visible_vcount;

	wire [8:0]   extr_data_addr;
	wire [15:0]  extr_data;
	wire [15:0]  update_data;
	wire [9:0]   update_data_wr;
	wire [4:0]   update_data_addr;
	wire [4:0]   ram_addrb;
	wire [159:0] ram_doutb;
	wire [15:0]  TFT_rgb;  //TFT
	wire         TFT_hs;   //TFTͬź
	wire         TFT_vs;   //TFTͬź
	wire         TFT_clk;  //TFTʱ
	wire         TFT_de;   //TFTʹ
	wire         TFT_pwm;  //TFT
	
	wire tft_reset_p;
    wire [4:0]Disp_Red;
    wire [5:0]Disp_Green;
    wire [4:0]Disp_Blue;
    wire Frame_Begin;

	initial clk50M = 1;
	always#(`CLK_PERIOD/2)clk50M = ~clk50M;

	initial begin
    reset_n = 1'b0;
    disp_data = 40'h0123456789;
    scan_en_pulse = 1'b0;
    #(`CLK_PERIOD*20 + 1 );
    reset_n = 1'b1;
    #(`CLK_PERIOD*50);

    @(posedge pll_locked);
    #200;
    scan_en_pulse = 1'b1;
    #(`CLK_PERIOD)
    scan_en_pulse = 1'b0;

    @(negedge TFT_vs);
    #2000;
    disp_data = 40'h3402567891;
    scan_en_pulse = 1'b1;
    #(`CLK_PERIOD)
    scan_en_pulse = 1'b0;
    
    @(negedge TFT_vs);
    #20000;
    $stop;	
	end
  
	assign sys_reset_n = pll_locked;

	pll pll
	(
    // Clock out ports
    .clk_out1(clk_ctrl    ), // output clk_out133M
    // Status and control signals
    .resetn  (reset_n     ), // input reset,active low
    .locked  (pll_locked  ), // output locked
    // Clock in ports
    .clk_in1 (clk50M      )  // input clk_in1
	);

	num_lib_rom num_lib_rom (
    .clka  (clk_ctrl       ), // input wire clka
    .addra (extr_data_addr ), // input wire [8 : 0] addra
    .douta (extr_data      )  // output wire [15 : 0] douta
	);

	assign update_data = extr_data;

	data_scan_ctrl data_scan_ctrl
	(
    .clk               (clk_ctrl         ),
    .reset_n           (sys_reset_n      ),
    .scan_en_pulse     (scan_en_pulse    ),
    .disp_data         (disp_data        ),
    .extr_data_addr    (extr_data_addr   ),
    .update_data_wr    (update_data_wr   ),
    .update_data_addr  (update_data_addr )
	);

	genvar i;
	generate
	for (i=0; i < 10; i=i+1)
	begin: num_dpram
    num_dpram num_dpram_inst (
		.clka  (clk_ctrl          ), // input wire clka
		.wea   (update_data_wr[i] ), // input wire [0 : 0] wea
		.addra (update_data_addr  ), // input wire [4 : 0] addra
		.dina  (update_data       ), // input wire [15 : 0] dina
		.clkb  (clk_ctrl          ), // input wire clkb
		.addrb (ram_addrb         ), // input wire [4 : 0] addrb
		.doutb (ram_doutb[16*(i+1)-1:16*i] )  // output wire [15 : 0] doutb
		);
	end
	endgenerate
  
	char_extract
	#(
		.H_Visible_area  (   800    ), //TFTĻ
		.V_Visible_area  (   480    ), //TFTĻ߶
		.CHAR_DISP_W     (   160    ), //ʾַȣ16x10
		.CHAR_DISP_H     (   32     ), //ʾַ߶
		.CHAR_ROM_ADDR_W (   5      ),
		.DISP_DATA_W     (   16     )
	)char_extract
	(
		.clk_ctrl        (clk_ctrl         ),
		.reset_n         (sys_reset_n      ),
		.char_disp_hbegin(200              ),
		.char_disp_vbegin(200              ),
		.disp_back_color (16'h0            ),
		.disp_char_color (16'hffff         ),
		.rom_addra       (ram_addrb        ),
		.rom_data        (ram_doutb        ),
		.Frame_Begin     (Frame_Begin),
		.disp_data_req   (tft_disp_data_req),
		.visible_hcount  (visible_hcount   ),
		.visible_vcount  (visible_vcount   ),
		.disp_data       (tft_disp_data    )
	);

	disp_driver disp_driver
	(
		.ClkDisp(clk_ctrl),
		.Rst_p(tft_reset_p),

		.Data(tft_disp_data),//źԤӲROMַ̬ƹʹõdisp_datadata_scan_ctrlͬıƣȫͬ
		.DataReq(tft_disp_data_req),//źԤӲROMַ̬ƹʹõdisp_data_reqdata_scan_ctrlͬıƣȫͬ

		.H_Addr(visible_hcount),
		.V_Addr(visible_vcount),
                            
		.Disp_HS(TFT_hs),
		.Disp_VS(TFT_vs),
		.Disp_Red(Disp_Red),
		.Disp_Green(Disp_Green),
		.Disp_Blue(Disp_Blue),
		.Frame_Begin(Frame_Begin),
                            
		.Disp_DE(TFT_de),
		.Disp_PCLK(TFT_clk)
	);

	assign tft_reset_p = ~pll_locked; //໷ṩTFTλźŽȡߵƽλ	
	assign TFT_rgb={Disp_Red,Disp_Green,Disp_Blue};
//	assign TFT_clk=Disp_PCLK;źתϲļıƺȡ
	assign TFT_pwm=1'b1;

endmodule
