/////////////////////////////////////////////////////////////////////////////////
// Company: 人о·Ƽ޹˾
// Engineer: С÷Ŷ
// Web: www.corecourse.cn
// 
// Create Date: 2020/07/20 00:00:00
// Design Name: dync_char_tft
// Module Name: char_extract
// Project Name: dync_char_tft
// Target Devices: XC7A35T-2FGG484I
// Tool Versions: Vivado 2018.3
// Description: ַĳ
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////

module char_extract
#(
  parameter H_Visible_area    = 800, //Ļʾ
  parameter V_Visible_area    = 480, //Ļʾ߶
  parameter CHAR_WIDTH        = 16 , //ַʾ
  parameter CHAR_HEIGHT       = 32 , //ַʾ߶
  parameter ROW_DISP_CHAR_NUM = 10 , //һʾַ
  parameter COL_DISP_CHAR_NUM = 2  , //ʾַ
  parameter CHAR_ROM_ADDR_W   = 5  , //洢ַROMַλlog2(CHAR_HEIGHT * COL_DISP_CHAR_NUM)
  parameter DISP_DATA_W       = 16   //ͼƬصλ
)
(
  clk_ctrl,
  reset_n,
  char_disp_hbegin,
  char_disp_vbegin,
  disp_back_color,
  disp_char_color,
  Frame_Begin,
  rom_addra,
  rom_data,
  disp_data_req,
  visible_hcount,
  visible_vcount,
  disp_data
);
localparam DISP_CHAR_TOTAL_W = CHAR_WIDTH  * ROW_DISP_CHAR_NUM;
localparam DISP_CHAR_TOTAL_H = CHAR_HEIGHT * COL_DISP_CHAR_NUM;

  input                         clk_ctrl;         //ʱ룬TFTʱӱһ
  input                         reset_n;          //λźţ͵ƽЧ

  input  [15:0]                 char_disp_hbegin; //ʾͼƬϽǵһصTFT
  input  [15:0]                 char_disp_vbegin; //ʾͼƬϽǵһصTFTĳ
  input  [DISP_DATA_W-1:0]      disp_back_color;  //ʾıɫ
  input  [DISP_DATA_W-1:0]      disp_char_color;  //ʾַɫ

  input                         Frame_Begin;      //һ֡ͼʼʶźţclk_ctrlʱ
  output[CHAR_ROM_ADDR_W-1:0]   rom_addra;        //ַromַ                  
  input [DISP_CHAR_TOTAL_W-1:0] rom_data;         //ַ
  input                         disp_data_req;    //
  input  [11:0]                 visible_hcount;   //TFTɼɨ
  input  [11:0]                 visible_vcount;   //TFTɼɨ
  output [DISP_DATA_W-1:0]      disp_data;        //ʾ

  reg  [CHAR_ROM_ADDR_W-1:0]   rom_addra;        //ͼƬromַ  
  wire                         h_exceed;
  wire                         v_exceed;
  wire                         char_h_disp;
  wire                         char_v_disp;
  wire                         char_disp;
  wire [15:0]                  hcount_max;
  reg  [DISP_CHAR_TOTAL_W-1:0] char_flag;

  //жõʾʼλǷᵼʾΧ
  assign h_exceed = char_disp_hbegin + DISP_CHAR_TOTAL_W > H_Visible_area - 1'b1;
  assign v_exceed = char_disp_vbegin + DISP_CHAR_TOTAL_H > V_Visible_area - 1'b1;
  //ͬʾͬĴ
  assign char_h_disp = h_exceed ? (visible_hcount >= char_disp_hbegin && visible_hcount < H_Visible_area):
                                  (visible_hcount >= char_disp_hbegin && visible_hcount < char_disp_hbegin + DISP_CHAR_TOTAL_W);  
  
  assign char_v_disp = v_exceed ? (visible_vcount >= char_disp_vbegin && visible_vcount < V_Visible_area):
                                  (visible_vcount >= char_disp_vbegin && visible_vcount < char_disp_vbegin + DISP_CHAR_TOTAL_H);

  assign char_disp = disp_data_req && char_h_disp && char_v_disp;
  
  assign hcount_max = h_exceed ? (H_Visible_area - 1'b1):(char_disp_hbegin + DISP_CHAR_TOTAL_W - 1'b1);
     
  always@(posedge clk_ctrl or negedge reset_n)
  begin
    if(!reset_n)
      rom_addra <= 'd0;
    else if(Frame_Begin)
      rom_addra <= 'd0; 
    else if((visible_hcount == hcount_max) && char_disp)
      rom_addra <= rom_addra + 1'b1;
    else
      rom_addra <= rom_addra;
  end

  always@(posedge clk_ctrl or negedge reset_n)
  begin
    if(!reset_n)
      char_flag <= 'd0;
    else if(char_disp)
      char_flag[DISP_CHAR_TOTAL_W-1:0] <= {char_flag[DISP_CHAR_TOTAL_W-2:0],1'b0};
    else
      char_flag <= rom_data[DISP_CHAR_TOTAL_W-1:0];
  end

  assign disp_data = (char_disp && char_flag[DISP_CHAR_TOTAL_W-1]) ? disp_char_color : disp_back_color;

 endmodule