//////////////////////////////////////////////////////////////////////////////////
// Company: 人о·Ƽ޹˾
// Engineer: С÷Ŷ
// Web: www.corecourse.cn
// 
// Create Date: 2020/07/20 22:48:59
// Design Name: dync_char_tft
// Module Name: dync_char_tft
// Project Name: dync_char_tft
// Target Devices: XC7A35T-2FGG484I
// Tool Versions: Vivado 2018.3
// Description: rom_char_tftĿĶļ֧໷ҺַʾЭ
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////

module dync_char_tft(
    clk50M,
    reset_n,

    TFT_rgb,
    TFT_hs,
    TFT_vs,
    TFT_clk,
    TFT_de,
    TFT_pwm
);

input         clk50M;   //ϵͳʱ룬50M
input         reset_n;  //λź룬Ч

output [15:0] TFT_rgb;  //TFT
output        TFT_hs;   //TFTͬź
output        TFT_vs;   //TFTͬź
output        TFT_clk;  //TFTʱ
output        TFT_de;   //TFTʹ
output        TFT_pwm;  //TFT
//ôʾɫַɫ
parameter DISP_BACK_COLOR = 16'h001F; //ɫ
parameter DISP_CHAR_COLOR = 16'h07E0; //ʾɫ
//궨Ļߴ
parameter TFT_WIDTH  = 800;
parameter TFT_HEIGHT = 480;

parameter ROW_DISP_CHAR_NUM = 10;//һʾַ
parameter COL_DISP_CHAR_NUM = 8; //Ҫʾַ
parameter CHAR_ROM_ADDR_W   = 8; //log2(32 * COL_DISP_CHAR_NUM)

//ַʾĻмλãɸҪط
parameter DISP_HBEGIN = (TFT_WIDTH  - ROW_DISP_CHAR_NUM*16)/2;
parameter DISP_VBEGIN = (TFT_HEIGHT - COL_DISP_CHAR_NUM*32 )/2;

wire         pll_locked;
wire         clk_ctrl;
wire         sys_reset_n;
wire [15:0]  tft_disp_data;
wire         tft_disp_data_req;
wire [11:0]  visible_hcount;
wire [11:0]  visible_vcount;

reg          scan_en_pulse;
wire [ROW_DISP_CHAR_NUM*COL_DISP_CHAR_NUM*4-1:0]  disp_data_pre;
reg  [ROW_DISP_CHAR_NUM*COL_DISP_CHAR_NUM*4-1:0]  disp_data;
wire [8:0]   extr_data_addr;
wire [15:0]  extr_data;
wire [15:0]  update_data;
wire [ROW_DISP_CHAR_NUM*COL_DISP_CHAR_NUM-1:0]   update_data_wr;
wire [4:0]   update_data_addr;
wire [CHAR_ROM_ADDR_W-1:0]   ram_addrb;
wire [16*ROW_DISP_CHAR_NUM-1:0] ram_doutb; 

assign sys_reset_n = pll_locked;

wire tft_reset_p;
wire [4:0]Disp_Red;
wire [5:0]Disp_Green;
wire [4:0]Disp_Blue;
wire [15:0]TFT_rgb;
wire Frame_Begin;

//-----------------------------------------------------
// debug
//-----------------------------------------------------
vio_0 vio_inst0 (
  .clk       (clk_ctrl             ), // input wire clk
  .probe_out0(disp_data_pre[159:0] )  // output wire [159 : 0] probe_out0
);

vio_0 vio_inst1 (
  .clk       (clk_ctrl             ), // input wire clk
  .probe_out0(disp_data_pre[319:160] )  // output wire [159 : 0] probe_out0
);

always@(posedge clk_ctrl or negedge sys_reset_n)
begin
  if(~sys_reset_n)
    disp_data <= 'd0;
  else
    disp_data <= disp_data_pre;
end

always@(posedge clk_ctrl or negedge sys_reset_n)
begin
  if(~sys_reset_n)
    scan_en_pulse <= 1'b0;
  else if(disp_data != disp_data_pre)
    scan_en_pulse <= 1'b1;
  else
    scan_en_pulse <= 1'b0;
end
//-----------------------------------------------------
pll pll
(
  // Clock out ports
  .clk_out1(clk_ctrl    ), // output clk_out133M
  // Status and control signals
  .resetn  (reset_n     ), // input reset,active low
  .locked  (pll_locked  ), // output locked
  // Clock in ports
  .clk_in1 (clk50M      )  // input clk_in1
);

num_lib_rom num_lib_rom (
  .clka  (clk_ctrl       ), // input wire clka
  .addra (extr_data_addr ), // input wire [8 : 0] addra
  .douta (extr_data      )  // output wire [15 : 0] douta
);

assign update_data = extr_data;

data_scan_ctrl #(
  .ROW_DISP_CHAR_NUM(ROW_DISP_CHAR_NUM), //һʾַ
  .COL_DISP_CHAR_NUM(COL_DISP_CHAR_NUM)  //ʾַ
)data_scan_ctrl
(
  .clk               (clk_ctrl         ),
  .reset_n           (sys_reset_n      ),
  .scan_en_pulse     (scan_en_pulse    ),
  .disp_data         (disp_data        ),
  .extr_data_addr    (extr_data_addr   ),
  .update_data_wr    (update_data_wr   ),
  .update_data_addr  (update_data_addr )
);

wire [16*ROW_DISP_CHAR_NUM-1:0]ram_doutb_tmp[COL_DISP_CHAR_NUM-1:0];

genvar i;
genvar j;
generate
  for (j=0; j < COL_DISP_CHAR_NUM; j=j+1)
  begin
    for (i=0; i < ROW_DISP_CHAR_NUM; i=i+1)
    begin: num_dpram
      num_dpram num_dpram_inst (
        .clka  (clk_ctrl          ), // input wire clka
        .wea   (update_data_wr[(j*ROW_DISP_CHAR_NUM)+i] ), // input wire [0 : 0] wea
        .addra (update_data_addr  ), // input wire [4 : 0] addra
        .dina  (update_data       ), // input wire [15 : 0] dina
        .clkb  (clk_ctrl          ), // input wire clkb
        .addrb (ram_addrb[4:0]         ), // input wire [4 : 0] addrb
        .doutb (ram_doutb_tmp[j][16*(i+1)-1:16*i] )  // output wire [15 : 0] doutb
      );
    end
  end

  assign ram_doutb = COL_DISP_CHAR_NUM > 1 ? ram_doutb_tmp[ram_addrb[CHAR_ROM_ADDR_W-1:5]] : ram_doutb_tmp[0];
endgenerate


char_extract
#(
  .H_Visible_area   (TFT_WIDTH        ), //Ļʾ
  .V_Visible_area   (TFT_HEIGHT       ), //Ļʾ߶
  .CHAR_WIDTH       (   16            ), //ַʾ
  .CHAR_HEIGHT      (   32            ), //ַʾ߶
  .ROW_DISP_CHAR_NUM(ROW_DISP_CHAR_NUM), //һʾַ
  .COL_DISP_CHAR_NUM(COL_DISP_CHAR_NUM), //ʾַ
  .CHAR_ROM_ADDR_W  (CHAR_ROM_ADDR_W  ), //洢ַROMַλlog2(CHAR_HEIGHT * COL_DISP_CHAR_NUM)
  .DISP_DATA_W      (   16            )  //ͼƬصλ
)char_extract
(
  .clk_ctrl        (clk_ctrl         ),
  .reset_n         (sys_reset_n      ),
  .char_disp_hbegin(DISP_HBEGIN      ),
  .char_disp_vbegin(DISP_VBEGIN      ),
  .disp_back_color (DISP_BACK_COLOR  ),
  .disp_char_color (DISP_CHAR_COLOR  ),
  .rom_addra       (ram_addrb        ),
  .rom_data        (ram_doutb        ),
  .Frame_Begin     (Frame_Begin),
  .disp_data_req   (tft_disp_data_req),
  .visible_hcount  (visible_hcount   ),
  .visible_vcount  (visible_vcount   ),
  .disp_data       (tft_disp_data    )
);

disp_driver disp_driver
(
    .ClkDisp     (clk_ctrl          ),
    .Rst_p       (tft_reset_p       ),

    .Data        (tft_disp_data     ),
    .DataReq     (tft_disp_data_req ),

    .H_Addr      (visible_hcount    ),
    .V_Addr      (visible_vcount    ),

    .Disp_HS     (TFT_hs            ),
    .Disp_VS     (TFT_vs            ),
    .Disp_Red    (Disp_Red          ),
    .Disp_Green  (Disp_Green        ),
    .Disp_Blue   (Disp_Blue         ),
    .Frame_Begin (Frame_Begin       ),

    .Disp_DE     (TFT_de            ),
    .Disp_PCLK   (TFT_clk           )
);

assign tft_reset_p = ~pll_locked;
assign TFT_rgb={Disp_Red,Disp_Green,Disp_Blue};
assign TFT_pwm=1'b1;

endmodule
